/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef __LSEARCH_SPEECH_H__
#define __LSEARCH_SPEECH_H__

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <glib.h>
#include <dbus/dbus.h>
#include <dbus/dbus-glib.h>
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/Xmu/WinUtil.h>
#include <X11/extensions/XTest.h>

#define DBUS_LSEARCH_NAME "com.deepin.lsearch"
#define DBUS_LSEARCH_PATH "/com/deepin/lsearch"
#define DBUS_LSEARCH_INFACE "com.deepin.lsearch"

#define sys_err(args ...)   { fprintf(stderr, args); }
#define sys_says(args ...)  { fprintf(stdout, args); }

void lsearch_init();
void exec_speech_rets();
void ldaemon_inface();
void init_config(const char* path);
void finalize_dbus_conn();
/* 解析识别后的结果，得到拼音 */
char *get_ret_pinyin();
/* 发送信号 */
void emit_dbus_signal(const char *dbus_path, const char *dbus_inface,
                      const char *signame, const char *sigvalue );
void exec_ret_bin(char *pinyin);
void dbus_send_keys_event(unsigned long xid, const char *buf_keys);
void set_key_state( Display *disp, int keycode, int state );
int strtok_num(char *exec_buf, int *nums);

#endif
