/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef __DBUS_INFACE_H__
#define __DBUS_INFACE_H__

#define CMD_LEN 128
#define TYPE_LEN    8

struct cmd_info {
    char cmd[CMD_LEN];
    char type[TYPE_LEN];
};

/* deepin-speech */
void dbus_vader();
int dbus_synth(const char *text, const char *out_file, int once_flag);
int dbus_recog(const char *in_file, const char *out_file);
void dbus_read_pcm(const char *str);
void dbus_read_str(const char *str, const char *out_pcm);
void dbus_read_file(const char *in_file, const char *out_pcm);
void dbus_read_xsel(const char *out_file, const char *out_pcm);

/* deepin-config */
char *dbus_parse_ret(const char *path);
void dbus_exec_via_console(const char *cmd);
void dbus_exec_via_keys(unsigned long xid, const char *buf_keys);
void dbus_exec_via_func(const char *app_name, const char *method);
int dbus_json_init(const char *path);
struct cmd_info *dbus_get_cmd(const char *pinyin);
void hash_table_destroy();
dbus
/* deepin-pinyin */
void dbus_insert_pinyin(const char *file_path);
char *dbus_get_pinyin(const char *cmd_buf);

/* deepin-trie */
char *dbus_create_trie(char **str, int len);
GArray *dbus_search_trie(const char *keys, const char *decrypt);
void dbus_destroy_trie();

/* deepin-wnck */
unsigned long get_cur_xid();
void active_win_via_pid(unsigned long pid);
unsigned long get_pid_via_name(const char *process_name);
gchar *get_window_class (unsigned long xid);

#endif
