/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef __DBUS_CONFIG_H__
#define __DBUS_CONFIG_H__

#include "dbus_common.h"

#define DBUS_CONFIG_NAME    "com.deepin.speech_config"
#define DBUS_CONFIG_PATH    "/com/deepin/speech_config"
#define DBUS_CONFIG_INFACE  "com.deepin.speech_config"

#define CMD_LEN 128
#define TYPE_LEN    128

struct cmd_info {
    char cmd[CMD_LEN];
    char type[TYPE_LEN];
};

void dbus_config_inface();
char *dbus_parse_ret(char *str);

int dbus_json_init(const char *path);
struct cmd_info *dbus_get_cmd(const char *pinyin);
void hash_table_destroy();

char *get_cmd();
char *get_type();
void get_ret_via_pinyin(const char *pinyin);

void finalize_dbus_loop();

#endif
