/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef __DBUS_SPEECH_H__
#define __DBUS_SPEECH_H__

#include "dbus_common.h"

#define DBUS_SPEECH_NAME    "com.deepin.speech"
#define DBUS_SPEECH_PATH    "/com/deepin/speech"
#define DBUS_SPEECH_INFACE  "com.deepin.speech"

void dbus_speech_inface();
void init_pulse();

void record_pulse();
void listen_dbus_signal(const char *name);

void InitMsp();
void FinalizeMsp();
int InitSynth ();
void FinalizeSynth();
int InitQisr ();
void FinalizeQisr ();
int dbus_synth (const char *str, const char *dest_path);
gchar* dbus_recog (const char* pcm_file);

void dbus_gst_play (const char *file, const char *type, int repeat);
void dbus_gst_stop ();
void dbus_read_xsel(const char *dest_wav);
void dbus_read_str (const char* str, const char* dest_wav);
void finalize_dbus_loop();

#endif
