/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef __RECORD_H__
#define __RECORD_H__

#include "dbus_speech.h"

#include <pulse/simple.h>
#include <pulse/error.h>
#include <pulse/volume.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <assert.h>

#define BUFSIZE 1024

void emit_speech_signal(const char *signame, const double *sigvalue);
void record_end();
void parse_record();
static ssize_t loop_write(FILE *fp, const void*data, size_t size);

void pa_source_cb(pa_context *c, const pa_source_info *i, int eol, void *userdata);
void m_pa_server_info_cb(pa_context *c, const pa_server_info *i, void *userdate);
void pa_state_cb(pa_context *c, void *userdata);
void on_monitor_read_callback(pa_stream *p, size_t length, void *userdata);
void on_monitor_suspended_callback(pa_stream *p, void *userdata);
int m_pa_stream_connect(pa_context *pa_ctx);

#endif
