/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef __MY_TRIE_H__
#define __MY_TRIE_H__

#include "dbus_common.h"

#define BUF_LEN	20
#define EN_LEN	26

struct my_trie {
	int flag;	//是否有下标被存储
	int *num;	//存储词组下标
	int cnt;	//下标的个数
	char ch;
	struct my_trie *next[EN_LEN];
};

struct my_trie *trie_create_node(char ch);
int char_to_index(char ch);
struct my_trie *trie_init();
void trie_insert(const char *keys, int num, struct my_trie *root);
int *trie_find(const char *keys, int *num, struct my_trie *root);
void trie_destroy(struct my_trie *cur_trie);

#endif
