/**
 * Copyright (c) 2011 ~ 2012 Deepin, Inc.
 *               2011 ~ 2012 jouyouyun
 *
 * Author:      jouyouyun <jouyouwen717@gmail.com>
 * Maintainer:  jouyouyun <jouyouwen717@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 **/

#include "wnck_pro.h"

unsigned long get_cur_xid()
{
	Window active_xid = 0;
	WnckScreen *screen = NULL;
	WnckWindow *active_win = NULL;
	GList *window_l = NULL;

	gdk_init( NULL, NULL );
	screen = wnck_screen_get_default();
	wnck_screen_force_update(screen);
	active_win = wnck_screen_get_active_window(screen);

	window_l = wnck_screen_get_windows(screen);
	for ( ; window_l != NULL; window_l = window_l->next ) {
		WnckWindow *window = WNCK_WINDOW(window_l->data);
		/*if ( wnck_window_get_window_type(window) != WNCK_WINDOW_NORMAL ) {
			continue;
		}*/
		if ( window == active_win ) {
			active_xid = wnck_window_get_xid(window);
			//sys_says("active xid : 0x%x\n", active_xid);
			break;
		}
	}
	
	return (unsigned long)active_xid;
}

void active_win_via_pid(unsigned long pid)
{
	WnckScreen *screen = NULL;
	GList *window_l = NULL;

	gdk_init( NULL, NULL );
	screen = wnck_screen_get_default();
	wnck_screen_force_update(screen);

	window_l = wnck_screen_get_windows(screen);
	for ( ; window_l != NULL; window_l = window_l->next ) {
		WnckWindow *window = WNCK_WINDOW(window_l->data);
		if ( wnck_window_get_window_type(window) != WNCK_WINDOW_NORMAL ) {
			continue;
		}
		if ( pid == wnck_window_get_pid(window) ) {
			wnck_window_activate(window, 1);
			//sys_says("match_wid xid : 0x%x\n", match_wid);
			break;
		}
	}
	
	return ;
}

/*
 * 获取进程 ID
 */
unsigned long get_pid_via_name( const char *process_name )
{
	char buf[1024];
	unsigned long pid = 0;
	FILE *fp = NULL;
	
	printf("get_pid_via_name : %s\n", process_name);
	if ( memcmp(process_name, "wpp", 3) == 0 ) {
		sprintf( buf, "ps aux > /tmp/ps-aux && cat /tmp/ps-aux | grep wps-office \
		| sed -n 1p | awk '{print $2}' > /tmp/pid" );
	} else {
		sprintf( buf, "ps aux > /tmp/ps-aux && cat /tmp/ps-aux | grep %s | \
		sed -n 1p | awk '{print $2}' > /tmp/pid", process_name );
	}
	system(buf);
	
	system("rm -rf /tmp/ps-aux");
	if ( (fp = fopen("/tmp/pid", "r")) == NULL ) {
		sys_err("get_pid failed...\n");
		return 0;
	}
	fscanf(fp, "%lu", &pid);
	fclose(fp);
	system("rm -rf /tmp/pid");
	printf("get_pid_via_name : %lu\n", pid);
	
	return pid;
}

gchar *get_window_class (unsigned long xid)
{
    gchar *class_utf8;
    gchar *wm_class;
    unsigned long size;
    Display *disp;
    
    if ( xid == 0 ) {
		return NULL;
	}
    /* necessary to make g_get_charset() and g_locale_*() work */
    setlocale(LC_ALL, "");
    
    if (! (disp = XOpenDisplay(NULL))) {
        fputs("Cannot open display.\n", stderr);
        return NULL;
    }

    wm_class = get_property(disp, (Window)xid, XA_STRING, "WM_CLASS", &size);
    XCloseDisplay(disp);
    if (wm_class) {
        gchar *p_0 = strchr(wm_class, '\0');
        if (wm_class + size - 1 > p_0) {
            *(p_0) = '.';
        }
        class_utf8 = g_locale_to_utf8(wm_class, -1, NULL, NULL, NULL);
    }
    else {
        class_utf8 = NULL;
    }

    g_free(wm_class);
    
    return class_utf8;
}

static gchar *get_property (Display *disp, Window win, 
        Atom xa_prop_type, const gchar *prop_name, unsigned long *size) {
    Atom xa_prop_name;
    Atom xa_ret_type;
    int ret_format;
    unsigned long ret_nitems;
    unsigned long ret_bytes_after;
    unsigned long tmp_size;
    unsigned char *ret_prop;
    gchar *ret;
    
    xa_prop_name = XInternAtom(disp, prop_name, False);
    
    /* MAX_PROPERTY_VALUE_LEN / 4 explanation (XGetWindowProperty manpage):
     *
     * long_length = Specifies the length in 32-bit multiples of the
     *               data to be retrieved.
     */
    //printf("win id : 0X%x\n", win);
    if ( XGetWindowProperty(disp, win, xa_prop_name, 0, 
			MAX_PROPERTY_VALUE_LEN / 4, False,
            xa_prop_type, &xa_ret_type, &ret_format,     
            &ret_nitems, &ret_bytes_after, &ret_prop) != Success ) {
        p_verbose("Cannot get %s property.\n", prop_name);
        return NULL;
    }
  
    if (xa_ret_type != xa_prop_type) {
        //p_verbose("Invalid type of %s property.\n", prop_name);
        XFree(ret_prop);
        return NULL;
    }

    /* null terminate the result to make string handling easier */
    tmp_size = (ret_format / 8) * ret_nitems;
    ret = (gchar*)g_malloc(tmp_size + 1);
    memcpy(ret, ret_prop, tmp_size);
    ret[tmp_size] = '\0';

    if (size) {
        *size = tmp_size;
    }
    
    XFree(ret_prop);
    return ret;
}
